function tree = C45_train(patterns, targets, inc_node, discrete_dim)
[Ni, L]    					= size(patterns);
Uc         					= unique(targets);
tree.dim					= 0;
tree.split_loc				= inf;

if isempty(patterns)
    return;
end

if ((inc_node > L) | (L == 1) | (length(Uc) == 1))
    tempvec1=zeros(1,length(Uc));
    for ii=1:length(Uc)
        tempvec1(ii)=length(find(targets==Uc(ii)));
    end
    [m, largest] = max(tempvec1);
    tree.child	 = Uc(largest);
    return
end

for i = 1:length(Uc),
    Pnode(i) = length(find(targets == Uc(i))) / L;
end
Inode = -sum(Pnode.*log(Pnode)/log(2));

delta_Ib    = zeros(1, Ni);
split_loc	= ones(1, Ni)*inf;

for i = 1:Ni,
    data	= patterns(i,:);
    Ud      = unique(data);
    Nbins	= length(Ud);
    if (discrete_dim(i)),
        P	= zeros(length(Uc), Nbins);
        for j = 1:length(Uc),
            for k = 1:Nbins,
                indices 	= find((targets == Uc(j)) & (patterns(i,:) == Ud(k)));
                P(j,k) 	= length(indices);
            end
        end
        Pk          = sum(P);
        P           = P./(eps+repmat(Pk,size(P,1),1)); 
        Pk          = Pk/sum(Pk);
        info        = sum(-P.*log(eps+P)/log(2));
        delta_Ib(i) = (Inode-sum(Pk.*info))/-sum(Pk.*log(eps+Pk)/log(2));
    else
        P	= zeros(length(Uc), 2);
        [sorted_data, indices] = sort(data);
        sorted_targets = targets(indices);
        I	= zeros(1, L-1);
        for j = 1:L-1,
            for k =1:length(Uc),
                P(k,1) = length(find(sorted_targets(1:j) 	 == Uc(k)));
                P(k,2) = length(find(sorted_targets(j+1:end) == Uc(k)));
            end
            Pk      = sum(P); 
            P       = P./(eps+repmat(Pk,size(P,1),1)); 
            Pk      = Pk/sum(Pk);
            info	= sum(-P.*log(eps+P)/log(2)); 
            I(j)	= (Inode-sum(Pk.*info))/-sum(Pk.*log(eps+Pk)/log(2)); 
        end
        [delta_Ib(i), s] = max(I);
        split_loc(i) = sorted_data(s); 
    end
end

[m, dim]    = max(delta_Ib);
dims        = 1:Ni;
tree.dim    = dim;
dims(dim)=[]; 
Nf		= unique(patterns(dim,:));
Nbins	= length(Nf);
if (discrete_dim(dim)),
    for i = 1:Nbins,
        indices    	= find(patterns(dim, :) == Nf(i));
        if isempty(dims)
            tempvec1=zeros(1,length(Uc));
            for ii=1:length(Uc)
                tempvec1(ii)=length(find(targets(indices)==Uc(ii)));
            end
            [m, largest] 	= max(tempvec1);
            tree.child(i) 	= Uc(largest);
        else
            tree.child(i)	= C45_train(patterns(dims, indices), targets(indices), inc_node, discrete_dim(dims));
        end
    end
else
    tree.split_loc	= split_loc(dim);
    indices1		   	= find(patterns(dim,:) <= split_loc(dim));
    indices2	   		= find(patterns(dim,:) > split_loc(dim));
    if isempty(dims)
        tempvec1=zeros(1,length(Uc));
        for ii=1:length(Uc)
            tempvec1(ii)=length(find(targets(indices1)==Uc(ii)));
        end
        [m, largest] 	= max(tempvec1);
        tree.child(1) 	= Uc(largest);
        tempvec1=zeros(1,length(Uc));
        for ii=1:length(Uc)
            tempvec1(ii)=length(find(targets(indices2)==Uc(ii)));
        end
        [m, largest] 	= max(tempvec1);
        tree.child(2) 	= Uc(largest);
    else
        tree.child(1)	= C45_train(patterns(dims, indices1), targets(indices1), inc_node, discrete_dim(dims));
        tree.child(2)	= C45_train(patterns(dims, indices2), targets(indices2), inc_node, discrete_dim(dims));
    end
end